Merge branch 'tb/unicode-6.3-zero-width'
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
20
21 # Test the binaries we have just built.  The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25         # We allow tests to override this, in case they want to run tests
26         # outside of t/, e.g. for running tests on the test library
27         # itself.
28         TEST_DIRECTORY=$(pwd)
29 else
30         # ensure that TEST_DIRECTORY is an absolute path so that it
31         # is valid even if the current working directory is changed
32         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33 fi
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36         # Similarly, override this to store the test-results subdir
37         # elsewhere
38         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39 fi
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47         echo >&2 'error: you do not seem to have built git yet.'
48         exit 1
49 fi
50
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
53
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58         # do not redirect again
59         ;;
60 *' --tee '*|*' --va'*)
61         mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62         BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64          echo $? > $BASE.exit) | tee $BASE.out
65         test "$(cat $BASE.exit)" = 0
66         exit
67         ;;
68 esac
69
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83         my @env = keys %ENV;
84         my $ok = join("|", qw(
85                 TRACE
86                 DEBUG
87                 USE_LOOKUP
88                 TEST
89                 .*_TEST
90                 PROVE
91                 VALGRIND
92                 UNZIP
93                 PERF_
94         ));
95         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
96         print join("\n", @vars);
97 ')
98 unset XDG_CONFIG_HOME
99 unset GITPERLLIB
100 GIT_AUTHOR_EMAIL=author@example.com
101 GIT_AUTHOR_NAME='A U Thor'
102 GIT_COMMITTER_EMAIL=committer@example.com
103 GIT_COMMITTER_NAME='C O Mitter'
104 GIT_MERGE_VERBOSITY=5
105 GIT_MERGE_AUTOEDIT=no
106 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
107 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
108 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
109 export EDITOR
110
111 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
112 then
113         GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
114         export GIT_INDEX_VERSION
115 fi
116
117 # Add libc MALLOC and MALLOC_PERTURB test
118 # only if we are not executing the test with valgrind
119 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
120    test -n "$TEST_NO_MALLOC_CHECK"
121 then
122         setup_malloc_check () {
123                 : nothing
124         }
125         teardown_malloc_check () {
126                 : nothing
127         }
128 else
129         setup_malloc_check () {
130                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
131                 export MALLOC_CHECK_ MALLOC_PERTURB_
132         }
133         teardown_malloc_check () {
134                 unset MALLOC_CHECK_ MALLOC_PERTURB_
135         }
136 fi
137
138 # Protect ourselves from common misconfiguration to export
139 # CDPATH into the environment
140 unset CDPATH
141
142 unset GREP_OPTIONS
143 unset UNZIP
144
145 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
146 1|2|true)
147         echo "* warning: Some tests will not work if GIT_TRACE" \
148                 "is set as to trace on STDERR ! *"
149         echo "* warning: Please set GIT_TRACE to something" \
150                 "other than 1, 2 or true ! *"
151         ;;
152 esac
153
154 # Convenience
155 #
156 # A regexp to match 5 and 40 hexdigits
157 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
158 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
159
160 # Zero SHA-1
161 _z40=0000000000000000000000000000000000000000
162
163 # Line feed
164 LF='
165 '
166
167 export _x05 _x40 _z40 LF
168
169 # Each test should start with something like this, after copyright notices:
170 #
171 # test_description='Description of this test...
172 # This test checks if command xyzzy does the right thing...
173 # '
174 # . ./test-lib.sh
175 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
176                 TERM=$ORIGINAL_TERM &&
177                 export TERM &&
178                 [ -t 1 ] &&
179                 tput bold >/dev/null 2>&1 &&
180                 tput setaf 1 >/dev/null 2>&1 &&
181                 tput sgr0 >/dev/null 2>&1
182         ) &&
183         color=t
184
185 while test "$#" -ne 0
186 do
187         case "$1" in
188         -d|--d|--de|--deb|--debu|--debug)
189                 debug=t; shift ;;
190         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
191                 immediate=t; shift ;;
192         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
193                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
194         -h|--h|--he|--hel|--help)
195                 help=t; shift ;;
196         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
197                 verbose=t; shift ;;
198         --verbose-only=*)
199                 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
200                 shift ;;
201         -q|--q|--qu|--qui|--quie|--quiet)
202                 # Ignore --quiet under a TAP::Harness. Saying how many tests
203                 # passed without the ok/not ok details is always an error.
204                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
205         --with-dashes)
206                 with_dashes=t; shift ;;
207         --no-color)
208                 color=; shift ;;
209         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
210                 valgrind=memcheck
211                 shift ;;
212         --valgrind=*)
213                 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
214                 shift ;;
215         --valgrind-only=*)
216                 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
217                 shift ;;
218         --tee)
219                 shift ;; # was handled already
220         --root=*)
221                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
222                 shift ;;
223         *)
224                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
225         esac
226 done
227
228 if test -n "$valgrind_only"
229 then
230         test -z "$valgrind" && valgrind=memcheck
231         test -z "$verbose" && verbose_only="$valgrind_only"
232 elif test -n "$valgrind"
233 then
234         verbose=t
235 fi
236
237 if test -n "$color"
238 then
239         say_color () {
240                 (
241                 TERM=$ORIGINAL_TERM
242                 export TERM
243                 case "$1" in
244                 error)
245                         tput bold; tput setaf 1;; # bold red
246                 skip)
247                         tput setaf 4;; # blue
248                 warn)
249                         tput setaf 3;; # brown/yellow
250                 pass)
251                         tput setaf 2;; # green
252                 info)
253                         tput setaf 6;; # cyan
254                 *)
255                         test -n "$quiet" && return;;
256                 esac
257                 shift
258                 printf "%s" "$*"
259                 tput sgr0
260                 echo
261                 )
262         }
263 else
264         say_color() {
265                 test -z "$1" && test -n "$quiet" && return
266                 shift
267                 printf "%s\n" "$*"
268         }
269 fi
270
271 error () {
272         say_color error "error: $*"
273         GIT_EXIT_OK=t
274         exit 1
275 }
276
277 say () {
278         say_color info "$*"
279 }
280
281 test "${test_description}" != "" ||
282 error "Test script did not set test_description."
283
284 if test "$help" = "t"
285 then
286         printf '%s\n' "$test_description"
287         exit 0
288 fi
289
290 exec 5>&1
291 exec 6<&0
292 if test "$verbose" = "t"
293 then
294         exec 4>&2 3>&1
295 else
296         exec 4>/dev/null 3>/dev/null
297 fi
298
299 test_failure=0
300 test_count=0
301 test_fixed=0
302 test_broken=0
303 test_success=0
304
305 test_external_has_tap=0
306
307 die () {
308         code=$?
309         if test -n "$GIT_EXIT_OK"
310         then
311                 exit $code
312         else
313                 echo >&5 "FATAL: Unexpected exit with code $code"
314                 exit 1
315         fi
316 }
317
318 GIT_EXIT_OK=
319 trap 'die' EXIT
320
321 # The user-facing functions are loaded from a separate file so that
322 # test_perf subshells can have them too
323 . "$TEST_DIRECTORY/test-lib-functions.sh"
324
325 # You are not expected to call test_ok_ and test_failure_ directly, use
326 # the test_expect_* functions instead.
327
328 test_ok_ () {
329         test_success=$(($test_success + 1))
330         say_color "" "ok $test_count - $@"
331 }
332
333 test_failure_ () {
334         test_failure=$(($test_failure + 1))
335         say_color error "not ok $test_count - $1"
336         shift
337         printf '%s\n' "$*" | sed -e 's/^/#      /'
338         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
339 }
340
341 test_known_broken_ok_ () {
342         test_fixed=$(($test_fixed+1))
343         say_color error "ok $test_count - $@ # TODO known breakage vanished"
344 }
345
346 test_known_broken_failure_ () {
347         test_broken=$(($test_broken+1))
348         say_color warn "not ok $test_count - $@ # TODO known breakage"
349 }
350
351 test_debug () {
352         test "$debug" = "" || eval "$1"
353 }
354
355 match_pattern_list () {
356         arg="$1"
357         shift
358         test -z "$*" && return 1
359         for pattern_
360         do
361                 case "$arg" in
362                 $pattern_)
363                         return 0
364                 esac
365         done
366         return 1
367 }
368
369 maybe_teardown_verbose () {
370         test -z "$verbose_only" && return
371         exec 4>/dev/null 3>/dev/null
372         verbose=
373 }
374
375 last_verbose=t
376 maybe_setup_verbose () {
377         test -z "$verbose_only" && return
378         if match_pattern_list $test_count $verbose_only
379         then
380                 exec 4>&2 3>&1
381                 # Emit a delimiting blank line when going from
382                 # non-verbose to verbose.  Within verbose mode the
383                 # delimiter is printed by test_expect_*.  The choice
384                 # of the initial $last_verbose is such that before
385                 # test 1, we do not print it.
386                 test -z "$last_verbose" && echo >&3 ""
387                 verbose=t
388         else
389                 exec 4>/dev/null 3>/dev/null
390                 verbose=
391         fi
392         last_verbose=$verbose
393 }
394
395 maybe_teardown_valgrind () {
396         test -z "$GIT_VALGRIND" && return
397         GIT_VALGRIND_ENABLED=
398 }
399
400 maybe_setup_valgrind () {
401         test -z "$GIT_VALGRIND" && return
402         if test -z "$valgrind_only"
403         then
404                 GIT_VALGRIND_ENABLED=t
405                 return
406         fi
407         GIT_VALGRIND_ENABLED=
408         if match_pattern_list $test_count $valgrind_only
409         then
410                 GIT_VALGRIND_ENABLED=t
411         fi
412 }
413
414 test_eval_ () {
415         # This is a separate function because some tests use
416         # "return" to end a test_expect_success block early.
417         eval </dev/null >&3 2>&4 "$*"
418 }
419
420 test_run_ () {
421         test_cleanup=:
422         expecting_failure=$2
423         setup_malloc_check
424         test_eval_ "$1"
425         eval_ret=$?
426         teardown_malloc_check
427
428         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
429         then
430                 setup_malloc_check
431                 test_eval_ "$test_cleanup"
432                 teardown_malloc_check
433         fi
434         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
435         then
436                 echo ""
437         fi
438         return "$eval_ret"
439 }
440
441 test_start_ () {
442         test_count=$(($test_count+1))
443         maybe_setup_verbose
444         maybe_setup_valgrind
445 }
446
447 test_finish_ () {
448         echo >&3 ""
449         maybe_teardown_valgrind
450         maybe_teardown_verbose
451 }
452
453 test_skip () {
454         to_skip=
455         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
456         then
457                 to_skip=t
458         fi
459         if test -z "$to_skip" && test -n "$test_prereq" &&
460            ! test_have_prereq "$test_prereq"
461         then
462                 to_skip=t
463         fi
464         case "$to_skip" in
465         t)
466                 of_prereq=
467                 if test "$missing_prereq" != "$test_prereq"
468                 then
469                         of_prereq=" of $test_prereq"
470                 fi
471
472                 say_color skip >&3 "skipping test: $@"
473                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
474                 : true
475                 ;;
476         *)
477                 false
478                 ;;
479         esac
480 }
481
482 # stub; perf-lib overrides it
483 test_at_end_hook_ () {
484         :
485 }
486
487 test_done () {
488         GIT_EXIT_OK=t
489
490         if test -z "$HARNESS_ACTIVE"
491         then
492                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
493                 mkdir -p "$test_results_dir"
494                 base=${0##*/}
495                 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
496
497                 cat >>"$test_results_path" <<-EOF
498                 total $test_count
499                 success $test_success
500                 fixed $test_fixed
501                 broken $test_broken
502                 failed $test_failure
503
504                 EOF
505         fi
506
507         if test "$test_fixed" != 0
508         then
509                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
510         fi
511         if test "$test_broken" != 0
512         then
513                 say_color warn "# still have $test_broken known breakage(s)"
514         fi
515         if test "$test_broken" != 0 || test "$test_fixed" != 0
516         then
517                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
518                 msg="remaining $test_remaining test(s)"
519         else
520                 test_remaining=$test_count
521                 msg="$test_count test(s)"
522         fi
523         case "$test_failure" in
524         0)
525                 # Maybe print SKIP message
526                 if test -n "$skip_all" && test $test_count -gt 0
527                 then
528                         error "Can't use skip_all after running some tests"
529                 fi
530                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
531
532                 if test $test_external_has_tap -eq 0
533                 then
534                         if test $test_remaining -gt 0
535                         then
536                                 say_color pass "# passed all $msg"
537                         fi
538                         say "1..$test_count$skip_all"
539                 fi
540
541                 test -d "$remove_trash" &&
542                 cd "$(dirname "$remove_trash")" &&
543                 rm -rf "$(basename "$remove_trash")"
544
545                 test_at_end_hook_
546
547                 exit 0 ;;
548
549         *)
550                 if test $test_external_has_tap -eq 0
551                 then
552                         say_color error "# failed $test_failure among $msg"
553                         say "1..$test_count"
554                 fi
555
556                 exit 1 ;;
557
558         esac
559 }
560
561 if test -n "$valgrind"
562 then
563         make_symlink () {
564                 test -h "$2" &&
565                 test "$1" = "$(readlink "$2")" || {
566                         # be super paranoid
567                         if mkdir "$2".lock
568                         then
569                                 rm -f "$2" &&
570                                 ln -s "$1" "$2" &&
571                                 rm -r "$2".lock
572                         else
573                                 while test -d "$2".lock
574                                 do
575                                         say "Waiting for lock on $2."
576                                         sleep 1
577                                 done
578                         fi
579                 }
580         }
581
582         make_valgrind_symlink () {
583                 # handle only executables, unless they are shell libraries that
584                 # need to be in the exec-path.
585                 test -x "$1" ||
586                 test "# " = "$(head -c 2 <"$1")" ||
587                 return;
588
589                 base=$(basename "$1")
590                 symlink_target=$GIT_BUILD_DIR/$base
591                 # do not override scripts
592                 if test -x "$symlink_target" &&
593                     test ! -d "$symlink_target" &&
594                     test "#!" != "$(head -c 2 < "$symlink_target")"
595                 then
596                         symlink_target=../valgrind.sh
597                 fi
598                 case "$base" in
599                 *.sh|*.perl)
600                         symlink_target=../unprocessed-script
601                 esac
602                 # create the link, or replace it if it is out of date
603                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
604         }
605
606         # override all git executables in TEST_DIRECTORY/..
607         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
608         mkdir -p "$GIT_VALGRIND"/bin
609         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
610         do
611                 make_valgrind_symlink $file
612         done
613         # special-case the mergetools loadables
614         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
615         OLDIFS=$IFS
616         IFS=:
617         for path in $PATH
618         do
619                 ls "$path"/git-* 2> /dev/null |
620                 while read file
621                 do
622                         make_valgrind_symlink "$file"
623                 done
624         done
625         IFS=$OLDIFS
626         PATH=$GIT_VALGRIND/bin:$PATH
627         GIT_EXEC_PATH=$GIT_VALGRIND/bin
628         export GIT_VALGRIND
629         GIT_VALGRIND_MODE="$valgrind"
630         export GIT_VALGRIND_MODE
631         GIT_VALGRIND_ENABLED=t
632         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
633         export GIT_VALGRIND_ENABLED
634 elif test -n "$GIT_TEST_INSTALLED"
635 then
636         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
637         error "Cannot run git from $GIT_TEST_INSTALLED."
638         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
639         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
640 else # normal case, use ../bin-wrappers only unless $with_dashes:
641         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
642         if ! test -x "$git_bin_dir/git"
643         then
644                 if test -z "$with_dashes"
645                 then
646                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
647                 fi
648                 with_dashes=t
649         fi
650         PATH="$git_bin_dir:$PATH"
651         GIT_EXEC_PATH=$GIT_BUILD_DIR
652         if test -n "$with_dashes"
653         then
654                 PATH="$GIT_BUILD_DIR:$PATH"
655         fi
656 fi
657 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
658 GIT_CONFIG_NOSYSTEM=1
659 GIT_ATTR_NOSYSTEM=1
660 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
661
662 if test -z "$GIT_TEST_CMP"
663 then
664         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
665         then
666                 GIT_TEST_CMP="$DIFF -c"
667         else
668                 GIT_TEST_CMP="$DIFF -u"
669         fi
670 fi
671
672 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
673 export GITPERLLIB
674 test -d "$GIT_BUILD_DIR"/templates/blt || {
675         error "You haven't built things yet, have you?"
676 }
677
678 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
679 then
680         echo >&2 'You need to build test-chmtime:'
681         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
682         exit 1
683 fi
684
685 # Test repository
686 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
687 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
688 case "$TRASH_DIRECTORY" in
689 /*) ;; # absolute path is good
690  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
691 esac
692 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
693 rm -fr "$TRASH_DIRECTORY" || {
694         GIT_EXIT_OK=t
695         echo >&5 "FATAL: Cannot prepare test area"
696         exit 1
697 }
698
699 HOME="$TRASH_DIRECTORY"
700 export HOME
701
702 if test -z "$TEST_NO_CREATE_REPO"
703 then
704         test_create_repo "$TRASH_DIRECTORY"
705 else
706         mkdir -p "$TRASH_DIRECTORY"
707 fi
708 # Use -P to resolve symlinks in our working directory so that the cwd
709 # in subprocesses like git equals our $PWD (for pathname comparisons).
710 cd -P "$TRASH_DIRECTORY" || exit 1
711
712 this_test=${0##*/}
713 this_test=${this_test%%-*}
714 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
715 then
716         say_color info >&3 "skipping test $this_test altogether"
717         skip_all="skip all tests in $this_test"
718         test_done
719 fi
720
721 # Provide an implementation of the 'yes' utility
722 yes () {
723         if test $# = 0
724         then
725                 y=y
726         else
727                 y="$*"
728         fi
729
730         while echo "$y"
731         do
732                 :
733         done
734 }
735
736 # Fix some commands on Windows
737 case $(uname -s) in
738 *MINGW*)
739         # Windows has its own (incompatible) sort and find
740         sort () {
741                 /usr/bin/sort "$@"
742         }
743         find () {
744                 /usr/bin/find "$@"
745         }
746         sum () {
747                 md5sum "$@"
748         }
749         # git sees Windows-style pwd
750         pwd () {
751                 builtin pwd -W
752         }
753         # no POSIX permissions
754         # backslashes in pathspec are converted to '/'
755         # exec does not inherit the PID
756         test_set_prereq MINGW
757         test_set_prereq NOT_CYGWIN
758         test_set_prereq SED_STRIPS_CR
759         test_set_prereq GREP_STRIPS_CR
760         GIT_TEST_CMP=mingw_test_cmp
761         ;;
762 *CYGWIN*)
763         test_set_prereq POSIXPERM
764         test_set_prereq EXECKEEPSPID
765         test_set_prereq NOT_MINGW
766         test_set_prereq CYGWIN
767         test_set_prereq SED_STRIPS_CR
768         test_set_prereq GREP_STRIPS_CR
769         ;;
770 *)
771         test_set_prereq POSIXPERM
772         test_set_prereq BSLASHPSPEC
773         test_set_prereq EXECKEEPSPID
774         test_set_prereq NOT_MINGW
775         test_set_prereq NOT_CYGWIN
776         ;;
777 esac
778
779 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
780 test -z "$NO_PERL" && test_set_prereq PERL
781 test -z "$NO_PYTHON" && test_set_prereq PYTHON
782 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
783 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
784
785 # Can we rely on git's output in the C locale?
786 if test -n "$GETTEXT_POISON"
787 then
788         GIT_GETTEXT_POISON=YesPlease
789         export GIT_GETTEXT_POISON
790         test_set_prereq GETTEXT_POISON
791 else
792         test_set_prereq C_LOCALE_OUTPUT
793 fi
794
795 # Use this instead of test_cmp to compare files that contain expected and
796 # actual output from git commands that can be translated.  When running
797 # under GETTEXT_POISON this pretends that the command produced expected
798 # results.
799 test_i18ncmp () {
800         test -n "$GETTEXT_POISON" || test_cmp "$@"
801 }
802
803 # Use this instead of "grep expected-string actual" to see if the
804 # output from a git command that can be translated either contains an
805 # expected string, or does not contain an unwanted one.  When running
806 # under GETTEXT_POISON this pretends that the command produced expected
807 # results.
808 test_i18ngrep () {
809         if test -n "$GETTEXT_POISON"
810         then
811             : # pretend success
812         elif test "x!" = "x$1"
813         then
814                 shift
815                 ! grep "$@"
816         else
817                 grep "$@"
818         fi
819 }
820
821 test_lazy_prereq PIPE '
822         # test whether the filesystem supports FIFOs
823         case $(uname -s) in
824         CYGWIN*)
825                 false
826                 ;;
827         *)
828                 rm -f testfifo && mkfifo testfifo
829                 ;;
830         esac
831 '
832
833 test_lazy_prereq SYMLINKS '
834         # test whether the filesystem supports symbolic links
835         ln -s x y && test -h y
836 '
837
838 test_lazy_prereq FILEMODE '
839         test "$(git config --bool core.filemode)" = true
840 '
841
842 test_lazy_prereq CASE_INSENSITIVE_FS '
843         echo good >CamelCase &&
844         echo bad >camelcase &&
845         test "$(cat CamelCase)" != good
846 '
847
848 test_lazy_prereq UTF8_NFD_TO_NFC '
849         # check whether FS converts nfd unicode to nfc
850         auml=$(printf "\303\244")
851         aumlcdiar=$(printf "\141\314\210")
852         >"$auml" &&
853         case "$(echo *)" in
854         "$aumlcdiar")
855                 true ;;
856         *)
857                 false ;;
858         esac
859 '
860
861 test_lazy_prereq AUTOIDENT '
862         sane_unset GIT_AUTHOR_NAME &&
863         sane_unset GIT_AUTHOR_EMAIL &&
864         git var GIT_AUTHOR_IDENT
865 '
866
867 # When the tests are run as root, permission tests will report that
868 # things are writable when they shouldn't be.
869 test -w / || test_set_prereq SANITY
870
871 GIT_UNZIP=${GIT_UNZIP:-unzip}
872 test_lazy_prereq UNZIP '
873         "$GIT_UNZIP" -v
874         test $? -ne 127
875 '